<!DOCTYPE html>
<html>
<head>
<title>ToDo API Client Demo</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link href="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/css/bootstrap-combined.min.css" rel="stylesheet">
<script src="http://ajax.aspnetcdn.com/ajax/jquery/jquery-1.9.0.js"></script>
<script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
<script src="http://ajax.aspnetcdn.com/ajax/knockout/knockout-2.2.1.js"></script>
</head>
<body>
    <div class="navbar">
        <div class="navbar-inner">
            <a class="brand" href="#">RUNE DEX Arbitrage Bot API Client</a>
        </div>
    </div>
    <div id="main" class="container">

        <table class="table table-striped">
            <tr>
                <td style="width: 15%;">
                    <table class="table table-striped">
                        <tr>
                            <td><button data-bind="click: getStatus" class="btn">Get Status</button></td>
                        </tr>
                        <tr>
                            <td><button data-bind="click: startBot" class="btn">Start Bot</button></td>
                        </tr>
                        <tr>
                            <td><button data-bind="click: stopBot" class="btn">Stop Bot</button></td>
                        </tr>
                        <tr>
                            <td><button data-bind="click: getTrades" class="btn">Get Trades</button></td>
                        </tr>
                        <tr>
                            <td><button data-bind="click: getLogs" class="btn">Get Logs</button></td>
                        </tr>
                    </table>
                </td>

                <td style="width: 1px;">
                    <span data-bind="visible: statusVisible">
                        <table class="table table-striped">
                            <td>
                                <table class="table table-striped">
                                    <tr><td>Status</td></tr>
                                    <tr>
                                        <td style="width: 1px;">
                                            <span data-bind="text: status"></span>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                            <td>
                                <table class="table table-striped">
                                    <tr><td>Trades</td><td>Avg PNL</td><td>Total volume</td><td>Avg Volume</td><td>Time running</td></tr>
                                    <!-- ko foreach: stats -->
                                    <tr>
                                        <td><span data-bind="text: tradeCount"></span></td>
                                        <td><span data-bind="text: avgPNL"></span></td>
                                        <td><span data-bind="text: totalVolume"></span></td>
                                        <td><span data-bind="text: avgTrade"></span></td>
                                        <td><span data-bind="text: timeRunning"></span></td>
                                    </tr>
                                    <!-- /ko -->
                                </table>
                            </td>
                        </table>
                    </span>
                </td>

                <td style="width: 1px;">
                    <span data-bind="visible: tradesVisible">
                        <table class="table table-striped">
                            <tr><td>time</td><td>amount in</td><td>amount out</td><td>P/L</td></tr>
                            <!-- ko foreach: trades -->
                            <tr>
                                <td><span data-bind="text: time"></span></td>
                                <td><span data-bind="text: amountIn"></span></td>
                                <td><span data-bind="text: amountOut"></span></td>
                                <td><span data-bind="text: pnl"></span></td>
                            </tr>
                            <!-- /ko -->
                        </table>
                    </span> 
                </td>

                <td style="width: 1px;">
                    <span data-bind="visible: logsVisible">
                        <table class="table table-striped">
                            <tr><td>Logs</td></tr>
                            <!-- ko foreach: logs -->
                            <tr>
                                <td><p><b data-bind="text: text"></b></p></td>
                            </tr>
                            <!-- /ko -->
                        </table>
                    </span>
                </td>


            </tr>
        </table>

    </div>
    <script type="text/javascript">


    function BotViewModel() {
        var self = this;

        self.botURI = 'http://localhost:8080/api/v1/';
        self.username = ''
        self.password = ''

        self.ajax = function(uri, method, data) {
            var request = {
                url: uri,
                type: method,
                contentType: "application/json",
                accepts: "application/json",
                cache: false,
                dataType: 'json',
                data: JSON.stringify(data),
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", "Basic " + btoa(self.username + ":" + self.password));
                },
                error: function(jqXHR) {
                    console.log("ajax error " + jqXHR.status);
                    alert("ajax error " + jqXHR.status);
                    var msg = '';
                    if (jqXHR.status === 0) {
                        msg = 'Cannot connect. Verify Network.';
                    } else if (jqXHR.status == 404) {
                        msg = 'Requested page not found. [404]';
                    } else if (jqXHR.status == 500) {
                        msg = 'Internal Server Error [500].';
                    } else if (exception === 'parsererror') {
                        msg = 'Requested JSON parse failed.';
                    } else if (exception === 'timeout') {
                        msg = 'Time out error.';
                    } else if (exception === 'abort') {
                        msg = 'Ajax request aborted.';
                    } else {
                        msg = 'Uncaught Error.\n' + jqXHR.responseText;
                    }
                    alert(msg)
                }
            };
            return $.ajax(request);
        }
        self.trades = ko.observableArray();
        self.logs = ko.observableArray();
        self.stats = ko.observableArray();
        self.status = ko.observable('');

        self.tradesVisible = ko.observable('false');
        self.logsVisible = ko.observable('false');
        self.statusVisible = ko.observable('false');




        function hideAll() {
            self.tradesVisible(false);
            self.logsVisible(false);
            self.statusVisible(false);
        }

        self.getStatus = function() {
            hideAll();
            self.statusVisible(true);
            self.ajax(self.botURI + "status", 'GET').done(function(data) {
                if (data != null) {
                    self.status(data.status);
                }
            });
            self.ajax(self.botURI + "stats", 'GET').done(function(data) {
                if (data != null) {
                    self.stats([
                        {
                            tradeCount: ko.observable(data.tradeCount),
                            avgPNL: ko.observable(data.avgPNL),
                            totalVolume: ko.observable(data.totalVolume),
                            avgTrade: ko.observable(data.avgTrade),
                            timeRunning: ko.observable(data.timeRunning),
                        }
                    ]);
                }
            });
        }
        self.startBot = function() {
            self.ajax(self.botURI + "start", 'POST').done(function() {
                self.getStatus()
            });
        }
        self.stopBot = function() {
            self.ajax(self.botURI + "stop", 'POST').done(function() {
                self.getStatus()
            });
        }
        self.getTrades = function() {
            hideAll();
            self.tradesVisible(true);
            self.ajax(self.botURI + "trades/100", 'GET').done(function(data) {
                self.trades([]);
                if (data != null) {
                    for (var i = 0; i < data.length; i++) {
                        self.trades.push({
                            time: ko.observable(data[i].time),
                            amountIn: ko.observable(data[i].amountIn),
                            amountOut: ko.observable(data[i].amountOut),
                            pnl: ko.observable(data[i].pnl)
                        });
                    }
                }
            });
        }
        self.getLogs = function() {
            hideAll();
            self.logsVisible(true);
            self.ajax(self.botURI + "logs/100", 'GET').done(function(data) {
                self.logs([]);
                if (data != null) {
                    for (var i = 0; i < data.length; i++) {
                        self.logs.push({
                            text: ko.observable(data[i].text)
                        });
                    }
                }
            });
        }
    }

    ko.applyBindings(new BotViewModel(), $('#main')[0]);

    </script>
</body>
</html>